<?php
// Note that this file/feature requires GD libraries installed on the php server

// set to defaults if variables were not passed
if(!isset($size)) $size=200;
if(!isset($font)) $font=4;

// process data
$data = unserialize( stripslashes($data) );
$items = count($data);

// Create a new image
$side_margin = $size * 2/3;
$top_margin  = $size / 10;
$im = ImageCreate($size+$side_margin*2, $size+$top_margin*2);

// Allocate the colors for the image
$white   = ImageColorAllocate($im, 255, 255, 255);  // background
$black   = ImageColorAllocate($im, 0, 0, 0);
$red     = ImageColorAllocate($im, 255, 64, 0);
$green   = ImageColorAllocate($im, 0, 64, 0);
$blue    = ImageColorAllocate($im, 208, 220, 224);  //#D0DCE0
$lt_blue = ImageColorAllocate($im, 142, 157, 224);  //#8E9DE0
$dk_blue = ImageColorAllocate($im, 109, 120, 171);  //#6D78AB
$yellow  = ImageColorAllocate($im, 255, 255, 210);

// color background
//ImageFilledRectangle($im, 0, 0, $size+$side_margin*2, $size, $white);

// draw a circle
ImageArc( $im, $size/2+$side_margin, $size/2+$top_margin, $size, $size, 0, 360, $dk_blue);

// fill circle with color
ImageFill($im, $size/2+$side_margin, $size/2+$top_margin, $blue);

// draw a wedge
$last_angle = 0;
for( $ix=-1; $ix < $items; $ix++ )
{
	if($ix<0)
		$angle = 0; // draw a line at 0 degrees
	else
		$angle = deg2rad($data[$ix][1]*3.6)+$last_angle;

	$x1 = $size/2+$side_margin;
	$y1 = $size/2+$top_margin;

	$x2 = ($size/2)*cos($angle)+($size/2)+$side_margin;
	$y2 = ($size/2)*sin($angle)+($size/2)+$top_margin;
	ImageLine($im, $x1, $y1, $x2, $y2, $dk_blue ); // draw wedge

	$mid_angle = ($angle-$last_angle)/2;
	if($ix>=0 && $data[$ix][1]>2 ) // caption if over 2%
	{
	$x1 = ($size/4)*cos($mid_angle+$last_angle)+($size/2)+$side_margin;
	$y1 = ($size/4)*sin($mid_angle+$last_angle)+($size/2)+$top_margin;

	$x2 = ($size/2)*cos($mid_angle+$last_angle)+($size/2)+$side_margin;
	$y2 = ($size/2)*sin($mid_angle+$last_angle)+($size/2)+$top_margin;

	ImageArc( $im, $x1, $y1, $size/25, $size/25, 0, 360, $green);  // display caption
	ImageLine($im, $x1, $y1, $x2, $y2, $green );
	
	$text = $data[$ix][0]." ".round($data[$ix][1])."%"; // show percent
	if($mid_angle+$last_angle<deg2rad(90) || $mid_angle+$last_angle>deg2rad(270))
	{
		ImageLine($im, $x2, $y2, $x2+$side_margin, $y2, $green); // caption on right side
		ImageString($im, $font, $x2, $y2-15, $text, $black);
	}
	else
	{
		ImageLine($im, $x2, $y2, $x2-$side_margin, $y2, $green); // caption on left side
		ImageString($im, $font, $x2-$side_margin, $y2, $text, $black);		
	}
	}

	$last_angle = $angle;
}


// send header to expect a PNG image
Header("Content-Type: image/png");

// send image as PNG to browser
ImagePng($im);

// destroy image when done
ImageDestroy($im);

?>